Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool.pod	(revision 34921)
@@ -615,35 +759,39 @@
 minor warnings the behaviour of ExifTool may be changed to allow some
 questionable operations to proceed (such as extracting thumbnail and preview
-images even if they don't have a recognizable header).  Minor
-errors/warnings are denoted by '[minor]' at the start of the message.
+images even if they don't have a recognizable header).  Minor errors and
+warnings are denoted by "[minor]" at the start of the message, or "[Minor]"
+(with a capital "M") for warnings that affect processing when ignored.
 
 =item Lang
 
 Localized language for exiftool tag descriptions, etc.  Available languages
-are given by the Image::ExifTool::Lang module names (ie. 'fr').  If the
-specified language isn't available, the option is not changed.  May be set
-to undef to select the built-in default language.  Default is 'en'.
+are given by the Image::ExifTool::Lang module names (eg. 'fr', 'zh_cn').  If
+the specified language isn't available, the option is not changed.  May be
+set to undef to select the built-in default language.  Default is 'en'.
 
 =item LargeFileSupport
 
 Flag to indicate that 64-bit file offsets are supported on this system.
-Default is 0.
-
-=item List
-
-Flag to extract lists of PrintConv values into arrays instead of joining
-them into a string of values.  The L</ListSep> option specifies the
-separator used when combining values.  Default is 0.
-
-=item ListSep
-
-Separator string used to join lists of PrintConv values when L</List> option
-is not set.  Default is ', '.
+Default is undef.
+
+=item ListItem
+
+Return only a specific item from list-type values.  A value of 0 returns the
+first item in the list, 1 return the second item, etc.  Negative indices may
+also be used, with -1 representing the last item in the list.  Applies only
+to the top-level list of nested lists.  Default is undef to return all items
+in the list.
+
+=item ListJoin
+
+Separator used to join the PrintConv value of multi-item List-type tags into
+a single string.  If not defined, multi-item lists are returned as a list
+reference.  Does not affect ValueConv values.  Default is ', '.
 
 =item ListSplit
 
 Regular expression used to split values of list-type tags into individual
-items when writing.  (ie. use ',\\s*' to split a comma-separated list.) 
-Default is undef.
+items when writing.  (eg. use ',\\s*' to split a comma-separated list.)
+Split when writing either PrintConv or ValueConv values.  Default is undef.
 
 =item MakerNotes
@@ -655,17 +803,33 @@
 are:
 
-  0 - Do not extract writable subdirectories (default)
+  0 - Do not extract writable subdirectories (same as default of undef)
   1 - Extract and rebuild maker notes into self-contained block
   2 - Extract without rebuilding maker notes
 
+=item MDItemTags
+
+Flag to extract the OS X metadata item tags (see the "mdls" man page and
+L<Image::ExifTool::TagNames/MacOS MDItem Tags> for more information).
+
 =item MissingTagValue
 
-Value for missing tags in expressions evaluated by L</SetNewValuesFromFile>.
-If not set, a minor error is issued for missing values, or the value is set
-to '' if L</IgnoreMinorErrors> is set.  Default is undef.
+Value for missing tags in tag name expressions (or tags where the advanced
+formatting expression returns undef).  If not set, a minor error is issued
+for missing values, or the value is set to '' if L</IgnoreMinorErrors> is
+set.  Default is undef.
+
+=item NoMultiExif
+
+Raise error when attempting to write multi-segment EXIF in a JPEG image. 
+Default is undef.
+
+=item NoPDFList
+
+Flag to avoid splitting PDF list-type tag values into separate items.
+Default is undef.
 
 =item Password
 
-Password for processing password-protected PDF documents.  Ignored if a
+Password for reading/writing password-protected PDF documents.  Ignored if a
 password is not required.  Character encoding of the password is determined
 by the value of the Charset option at processing time.  Default is undef.
@@ -676,9 +840,60 @@
 print conversion for writing.  Default is 1.
 
+=item QuickTimeHandler
+
+Flag set to add an 'mdir' Handler to a newly created Meta box when adding
+QuickTime ItemList tags.  Adobe Bridge does not add this Handler, but it is
+commonly found in samples from other software, and it has been reported that
+Apple QuickTime Player and Photos.apps will ignore ItemList tags if this is
+missing.  Default is 1.
+
+=item QuickTimeUTC
+
+Flag set to assume that QuickTime date/time values are stored as UTC,
+causing conversion to local time when they are extracted and from local time
+when written.  According to the QuickTime specification date/time values
+should be UTC, but many digital cameras store local time instead (presumably
+because they don't know the time zone), so the default is to not convert
+these times (except for Canon CR3 files, which always use UTC times).  This
+option also disables the autodetection of incorrect time-zero offsets in
+QuickTime date/time values, and enforces a time zero of 1904 as per the
+QuickTime specification.
+
+=item RequestAll
+
+Flag to request all tags to be extracted.  This causes some tags to be
+generated which normally would not be unless specifically requested (by
+passing the tag name to L</ImageInfo> or L</ExtractInfo>).  May be set to 2
+or 3 to enable generation of some additional tags as mentioned in the tag
+name documentation.  Default is undef.
+
+=item RequestTags
+
+List of additional tag and/or group names to request in the next call to
+L</ExtractInfo>.  This option is useful only for tags/groups which aren't
+extracted unless specifically requested.  Value may be a list reference, a
+delimited string of names (any delimiter is allowed), or undef to clear the
+current RequestTags list.  Groups are requested by adding a colon after the
+name (eg. "MacOS:").  Names are converted to lower case as they are added to
+the list.  Default is undef.
+
+=item SaveFormat
+
+Flag to save EXIF/TIFF format type as the family 6 group name when
+extracting information.  Without this option set, the family 6 group names
+are not generated.  Default is undef.  See the L</GetGroup> option for more
+details.
+
+=item SavePath
+
+Flag to save the metadata path as the family 5 group name when extracting
+information.  Without this option set, the family 5 group names are not
+generated.  Default is undef.  See the L</GetGroup> option for more details.
+
 =item ScanForXMP
 
-Flag for scan all files (even unrecognized formats) for XMP information
+Flag to scan all files (even unrecognized formats) for XMP information
 unless XMP was already found in the file.  When combined with the FastScan
-option, only unrecognized file types are scanned for XMP.  Default is 0.
+option, only unrecognized file types are scanned for XMP.  Default is undef.
 
 =item Sort
@@ -687,6 +902,7 @@
 
   Input  - Sort in same order as input tag arguments (default)
-  Alpha  - Sort alphabetically
   File   - Sort in order that tags were found in the file
+  Tag    - Sort alphabetically by tag name
+  Descr  - Sort by tag description (for current Lang setting)
   Group# - Sort by tag group, where # is zero or more family
            numbers separated by colons. If # is not specified,
@@ -694,4 +910,12 @@
            of group families.
 
+=item Sort2
+
+Secondary sort order used for tags within each group when Sort is 'Group':
+
+  File   - Sort in order tags were found in the file (default)
+  Tag    - Sort alphabetically by tag name
+  Descr  - Sort by tag description (for current Lang setting)
+
 =item StrictDate
 
@@ -699,15 +923,35 @@
 the DateFormat option is used.  Default is undef.
 
+  undef - Same as 0 for reading/writing, or 1 for copying
+    0   - Return date/time value unchanged if it can't be converted
+    1   - Return undef if date/time value can't be converted
+
+When set to 1 while writing a PrintConv date/time value with the DateFormat
+option set, the value is written only if POSIX::strptime or Time::Piece is
+available and can successfully convert the value.
+
+For PNG CreationTime, a setting of 1 has the additional effect of causing
+the date/time to be reformatted according to PNG 1.2 recommendation
+(RFC-1123) when writing, and a warning to be issued for any non-standard
+value when reading (but note that Windows may not recognize PNG date/time
+values in standard format).
+
 =item Struct
 
 Flag to return XMP structures as hash references instead of flattening into
-individual tags.  If not defined (the default), tags are flattened when
-reading (with L<ExtractInfo>), and structured when copying (with
-L</SetNewValuesFromFile>).  Has no effect when writing since both flattened
-and structured tags may always be written.  Possible values are:
-
-  undef - Read flattened tags, copy structured tags (default)
-    0   - Read and copy flattened tags
-    1   - Read and copy structured tags
+individual tags.  Has no effect when writing since both flattened and
+structured tags may always be written.  Possible values are:
+
+  undef - (default) Same as 0 for reading, 2 for copying
+    0   - Read/copy flattened tags
+    1   - Read/copy structured tags
+    2   - Read/copy both flattened and structured tags, but flag
+          flattened tags as 'unsafe' for copying
+
+=item SystemTags
+
+Flag to extract the following additional File System tags:  FileAttributes,
+FileDeviceNumber, FileInodeNumber, FileHardLinks, FileUserID, FileGroupID,
+FileDeviceID, FileBlockSize and FileBlockCount.
 
 =item TextOut
@@ -715,4 +959,11 @@
 Output file reference for Verbose and HtmlDump options.  Default is
 \*STDOUT.
+
+=item TimeZone
+
+Time zone for local date/time values.  May be set to any valid TZ string.
+Uses the system time zone if not specified.  Default is undef.  (Requires
+POSIX::tzset, which may not be available in Windows.  A work-around in
+Windows is to C<set TZ=E<lt>zoneE<gt>> before running ExifTool.)
 
 =item Unknown
@@ -721,4 +972,32 @@
 extracted from EXIF (or other tagged-format) directories.  If set to 2,
 unknown tags are also extracted from binary data blocks.  Default is 0.
+
+=item UserParam
+
+Special option to set/get user-defined parameters.  Useful to allow external
+input into tag name expressions and ValueConv logic.  Valid UserParam values
+are:
+
+  PARAM         - Get parameter
+  PARAM=        - Clear parameter
+  PARAM^=       - Set parameter to empty string
+  PARAM=VALUE   - Set parameter
+  <hash ref>    - Set entire UserParam hash lookup
+  undef         - Clear all user parameters
+
+Where I<PARAM> is the user-defined parameter name (case insensitive).
+
+User-defined parameters may be accessed in tag name expressions by prefixing
+the parameter name with a dollar sign just like normal tags, or via the API
+by calling C<Options('UserParam','PARAM')>.  Appending a hash tag (C<#>) to
+the parameter name also causes the parameter to be extracted as a normal tag
+(in the UserParam group).  If called without additional arguments,
+C<Options('UserParam')> returns a reference to the hash of all user
+parameters (with lower-case names).
+
+=item Validate
+
+Flag to perform extra validation metadata checks when reading, causing extra
+warnings to be generated if problems are found.  Default is undef.
 
 =item Verbose
@@ -732,4 +1011,29 @@
 on tag values and JPEG segment data respectively.
 
+=item WriteMode
+
+Set tag write/create mode.  Value is a string of one or more characters from
+list below.  Default is 'wcg'.
+
+    w - Write existing tags
+    c - Create new tags
+    g - create new Groups as necessary
+
+The level of the group differs for different types of metadata. For XMP or
+IPTC this is the full XMP/IPTC block (the family 0 group), but for EXIF this
+is the individual IFD (the family 1 group).  The 'w' and 'c' modes are
+tested only when L</SetNewValue> is called, but the 'g' mode is also tested
+in L</WriteInfo>.
+
+=item XAttrTags
+
+Flag to extract the OS X extended attribute tags (see the "xattr" man page
+and L<Image::ExifTool::TagNames/MacOS XAttr Tags> for more information).
+
+=item XMPAutoConv
+
+Flag to enable automatic conversion for unknown XMP tags with values that
+look like rational numbers or dates.  Default is 1.
+
 =back
 
@@ -775,8 +1079,11 @@
 L</ExtractInfo>:
 
-Binary, Charset, CharsetID3, CharsetIPTC, Composite, ExtractEmbedded,
-FastScan, FixBase, HtmlDump, HtmlDumpBase, IgnoreMinorErrors, Lang,
-LargeFileSupport, MakerNotes, ScanForXMP, Struct, TextOut, Unknown and
-Verbose.
+Binary, Charset, CharsetEXIF, CharsetFileName, CharsetID3, CharsetIPTC,
+CharsetPhotoshop, CharsetQuickTime, CharsetRIFF, Composite, ExtendedXMP,
+ExtractEmbedded, FastScan, FixBase, HtmlDump, HtmlDumpBase,
+IgnoreMinorErrors, Lang, LargeFileSupport, MakerNotes, MDItemTags,
+NoPDFList, Password, QuickTimeUTC (enforced 1904 time zero), RequestAll,
+RequestTags, SaveFormat, SavePath, ScanForXMP, Struct, TextOut, Unknown,
+Verbose, XAttrTags and XMPAutoConv.
 
 =item Return Value:
@@ -793,6 +1100,9 @@
 L</ImageInfo>.
 
-    # get image width and hieght only
+    # get image width and height only
     $info = $exifTool->GetInfo('ImageWidth', 'ImageHeight');
+
+    # get all Error and Warning messages
+    $info = $exifTool->GetInfo('Error', 'Warning');
 
     # get information for all tags in list (list updated with tags found)
@@ -809,13 +1119,20 @@
 image can not be specified.  Options in effect are:
 
-Charset, CoordFormat, DateFormat, Duplicates, Escape, Exclude, Group#, Lang,
-List, ListSep, PrintConv, Sort (if a tag list reference is given) and
+Charset, CoordFormat, DateFormat, Duplicates, Escape, Exclude, Filter,
+Group#, GlobalTimeShift, Lang, ListItem, ListJoin, PrintConv, Sort (if a tag
+list reference is given) and StrictDate.
+
+=item Return Value:
+
+Reference to information hash, the same as with L</ImageInfo>.
+
+=back
+
+The following options are effective in the call to L</GetInfo>:
+
+Charset, CoordFormat, DateFormat, Duplicates, Escape, Exclude, Filter,
+Group#, GlobalTimeShift, Lang, ListItem, ListJoin, PrintConv, QuickTimeUTC
+(conversion to local time), Sort (if a tag list reference is given) and
 StrictDate.
-
-=item Return Value:
-
-Reference to information hash, the same as with L</ImageInfo>.
-
-=back
 
 =head2 WriteInfo
@@ -828,4 +1145,15 @@
 additional files without the need to call L</SetNewValue> again.
 
+ExifTool queues all new values that are assigned via calls to
+L</SetNewValue>, then applies them to any number of files through one or
+more calls to L</WriteInfo>. These queued values may be accessed through
+L</GetNewValue>, and are completely separate from metadata extracted from
+files via L</ExtractInfo> or L</ImageInfo> and accessed through L</GetInfo>
+or L</GetValue>.
+
+To be clear, it is NOT necessary to call L</ExtractInfo> or L</ImageInfo>
+before L</WriteInfo>.  L</WriteInfo> changes only metadata specified by
+previous calls to L</SetNewValue>.
+
     # add information to a source file, writing output to new file
     $exifTool->WriteInfo($srcfile, $dstfile);
@@ -844,10 +1172,12 @@
 
 1) Source file name, file reference, scalar reference, or undef to create a
-file from scratch
+file from scratch.  A reference to a
+L<File::RandomAccess|File::RandomAccess> object is also allowed as a source,
+but in this case the destination is not optional.
 
 2) [optional] Destination file name, file reference, scalar reference, or
-undef to overwrite the original file
-
-3) [optional] Destination file type
+undef to overwrite the original file.  May be '-' to write to stdout.
+
+3) [optional] Destination file type.  Ignored if a source is defined.
 
 =item Return Value:
@@ -867,19 +1197,20 @@
 
 The source file name may be undefined to create a file from scratch
-(currently only XMP, MIE, ICC, VRD and EXIF files can be created in this way
--- see L</CanCreate> for details).  If undefined, the destination file type
-is required unless the type can be determined from the destination file
-name.
+(currently only XMP, MIE, ICC, VRD, DR4, EXV and EXIF files can be created
+in this way -- see L</CanCreate> for details).  If undefined, the
+destination file type is required unless the type can be determined from the
+extension of the destination file name.
 
 If a destination file name is given, the specified file must not exist
-because an existing destination file will not be overwritten.  The
-destination file name may be undefined to overwrite the original file (make
-sure you have backups!).  In this case, if a source file name is provided, a
-temporary file is created and renamed to replace the source file if no
-errors occurred while writing.  Otherwise, if a source file reference or
-scalar reference is used, the image is first written to memory then copied
-back to replace the original if there were no errors.
-
-The destination file type is only used if the source file is undefined.
+because an existing destination file will not be overwritten.  Any new
+values for FileName, Directory or HardLink are ignored when a destination
+file name is specified.
+
+The destination file name may be undefined to overwrite the original file
+(make sure you have backups!).  In this case, if a source file name is
+provided, a temporary file is created and renamed to replace the source file
+if no errors occurred while writing.  Otherwise, if a source file reference
+or scalar reference is used, the image is first written to memory then
+copied back to replace the original if there were no errors.
 
 On Mac OS systems, the file resource fork is preserved if this routine is
@@ -890,12 +1221,13 @@
 The following ExifTool options are effective in the call to L</WriteInfo>:
 
-ByteOrder, Charset, CharsetID3, CharsetIPTC, Compact, Compress, FixBase,
-IgnoreMinorErrors and Verbose.
-
-=head2 CombineInfo
-
-Combine information from more than one information hash into a single hash.
-
-    $info = $exifTool->CombineInfo($info1, $info2, $info3);
+ByteOrder, Charset, CharsetEXIF, CharsetFileName, CharsetIPTC, Compact,
+Compress, FixBase, IgnoreMinorErrors, Password, QuickTimeHandler, Verbose
+and WriteMode.
+
+=head2 GetTagList
+
+Get a sorted list of tags from the specified information hash or tag list.
+
+    @tags = $exifTool->GetTagList($info, 'Group0');
 
 =over 4
@@ -905,28 +1237,9 @@
 0) ExifTool object reference
 
-1-N) Information hash references
-
-=back
-
-If the Duplicates option is disabled and duplicate tags exist, the order of
-the hashes is significant.  In this case, the value used is the first value
-found as the hashes are scanned in order of input.  The Duplicates option
-is the only option that is in effect for this function.
-
-=head2 GetTagList
-
-Get a sorted list of tags from the specified information hash or tag list.
-
-    @tags = $exifTool->GetTagList($info, 'Group0');
-
-=over 4
-
-=item Inputs:
-
-0) ExifTool object reference,
-
-1) [optional] Information hash reference or tag list reference,
-
-2) [optional] Sort order ('File', 'Input', 'Alpha' or 'Group#').
+1) [optional] Information hash reference or tag list reference
+
+2) [optional] Sort order ('Input', 'File', 'Tag', 'Descr' or 'Group#')
+
+3) [optional] Secondary sort order ('File', 'Tag' or 'Descr')
 
 If the information hash or tag list reference is not provided, then the list
@@ -956,5 +1269,7 @@
 0) ExifTool object reference
 
-1) [optional] Sort order ('File', 'Input', 'Alpha' or 'Group#')
+1) [optional] Sort order ('Input', 'File', 'Tag', 'Descr' or 'Group#')
+
+2) [optional] Secondary sort order ('File', 'Tag' or 'Descr')
 
 If sort order is not specified, the sort order from the ExifTool options is
@@ -994,16 +1309,17 @@
 Get the value of a specified tag.  The returned value is either the
 human-readable (PrintConv) value, the converted machine-readable (ValueConv)
-value, or the original raw (Raw) value.  If the value type is not specified,
-the PrintConv value is returned if the PrintConv option is set, otherwise
-the ValueConv value is returned.  The PrintConv values are same as the
-values returned by L</ImageInfo> and L</GetInfo> in the tag/value hash
-unless the PrintConv option is disabled.
+value, the original raw (Raw) value, or the original rational (Rational)
+value for rational formats.  If the value type is not specified, the
+PrintConv value is returned if the PrintConv option is set, otherwise the
+ValueConv value is returned.  The PrintConv values are same as the values
+returned by L</ImageInfo> and L</GetInfo> in the tag/value hash unless the
+PrintConv option is disabled.
 
 Tags which represent lists of multiple values (as may happen with 'Keywords'
 for example) are handled specially.  In scalar context, the returned
 PrintConv value for these tags is either a string of values or a list
-reference (depending on the List option setting), and the ValueConv value is
-always a list reference.  But in list context, L</GetValue> always returns
-the list itself.
+reference (depending on the ListJoin option setting), and the ValueConv
+value is always a list reference.  But in list context, L</GetValue> always
+returns the list itself.
 
 Note that L</GetValue> requires a case-sensitive tag key as an argument.  To
@@ -1031,8 +1347,9 @@
     my @keywords = $exifTool->GetValue('Keywords', 'ValueConv');
 
-The following options are in effect when <L/GetValue> is called:
-
-Charset, CoordFormat, DateFormat, Escape, Lang, List, ListSep, PrintConv and
-StrictDate.
+The following options are in effect when L</GetValue> is called:
+
+Charset, CoordFormat, DateFormat, Escape, Filter, GlobalTimeShift, Lang,
+ListItem, ListJoin, PrintConv, QuickTimeUTC (conversion to local time),
+StrictDate and TimeZone.
 
 =over 4
@@ -1042,23 +1359,30 @@
 0) ExifTool object reference
 
-1) Tag key
-
-2) [optional] Value type, 'PrintConv', 'ValueConv', 'Both' or 'Raw'
+1) Tag key, or case-sensitive tag name with optional group prefix(es)
+
+2) [optional] Value type: 'PrintConv', 'ValueConv', 'Both', 'Raw' or
+'Rational'
 
 The default value type is 'PrintConv' if the PrintConv option is set,
 otherwise the default is 'ValueConv'.  A value type of 'Both' returns both
-ValueConv and PrintConv values as a list.
+ValueConv and PrintConv values as a list.  'Rational' returns the raw
+rational value as a string fraction for rational types, or undef for other
+types.
 
 =item Return Values:
 
-The value of the specified tag.  If the tag represents a list of values and
-the List option is disabled then PrintConv returns a string of values,
-otherwise a reference to the list is returned in scalar context.  The list
-itself is returned in list context.  Values may also be scalar references to
-binary data, or hash references if the Struct option is set.
+The value of the specified tag.  If the tag represents a list of multiple
+values and the ListJoin option is enabled then PrintConv returns a string of
+values, otherwise a reference to the list is returned in scalar context. The
+list itself is returned in list context.  (Unless 'Both' values are
+requested, in which case two list references are returned, regardless of
+context.)  Values may also be scalar references to binary data, or hash
+references if the L</Struct> option is set.
 
 Note: It is possible for L</GetValue> to return an undefined ValueConv or
 PrintConv value (or an empty list in list context) even if the tag exists,
-since it is possible for these conversions to yield undefined values.
+since it is possible for these conversions to yield undefined values.  And
+the Rational value will be undefined for any non-rational tag.  The Raw
+value should always exist if the tag exists.
 
 =back
@@ -1089,5 +1413,5 @@
     $exifTool->SetNewValue('Keywords', $word, DelValue => 1);
 
-    # set keywords (a List-type tag) with two new values
+    # set keywords (a list-type tag) with two new values
     $exifTool->SetNewValue(Keywords => 'word1');
     $exifTool->SetNewValue(Keywords => 'word2');
@@ -1098,10 +1422,16 @@
     $exifTool->SetNewValue(Keywords => $word, AddValue => 1);
 
+    # conditionally add a tag if it didn't exist before,
+    # or replace it if it had a specified value ("old value")
+    $exifTool->SetNewValue(Description => '', DelValue => 1);
+    $exifTool->SetNewValue(Description => 'old value', DelValue => 1);
+    $exifTool->SetNewValue(Description => 'new value');
+
     # set a tag in a specific group
     $exifTool->SetNewValue(Headline => $val, Group => 'XMP');
     $exifTool->SetNewValue('XMP:Headline' => $val);  # (equivalent)
 
-    # shift original date/time back by 1 hour
-    $exifTool->SetNewValue(DateTimeOriginal => '1:00', Shift => -1);
+    # shift original date/time back by 2.5 hours
+    $exifTool->SetNewValue(DateTimeOriginal => '2:30', Shift => -1);
 
     # write a tag only if it had a specific value
@@ -1128,6 +1458,6 @@
     $exifTool->SetNewValue('XMP:Flash'=>'{mode=on,fired=true,return=not}');
 
-(See L<http://owl.phy.queensu.ca/~phil/exiftool/struct.html#Serialize> for
-a description of the structure serialization technique.)
+(See L<https://exiftool.org/struct.html#Serialize> for a description of the
+structure serialization technique.)
 
 =over 4
@@ -1137,10 +1467,17 @@
 0) ExifTool object reference
 
-1) [optional] Tag key or tag name, or undef to clear all new values.  A tag
-name of '*' can be used when deleting tags to delete all tags, or all tags
-in a specified group.  The tag name may be prefixed by group name, separated
-by a colon (ie. 'EXIF:Artist'), which is equivalent to using a Group option
-argument.  Also, a '#' may be appended to the tag name (ie.
-'EXIF:Orientation#'), with the same effect as setting Type to 'ValueConv'.
+1) [optional] Tag key or tag name, or undef to clear all new values.  The
+tag name may be prefixed by one or more family 0, 1 or 2 group names with
+optional leading family numbers, separated by colons (eg. 'EXIF:Artist',
+'XMP:Time:*'), which is equivalent to using a Group option argument.  Also,
+a '#' may be appended to the tag name (eg. 'EXIF:Orientation#'), with the
+same effect as setting Type to 'ValueConv'.  Wildcards ('*' and '?') may be
+used in the tag name to assign multiple tags simultaneously.  A tag name of
+'*' is special when deleting information, and will delete an entire group
+even if some individual tags in the group are not writable, but only if a
+single family 0 or 1 group is specified (otherwise the tags are deleted
+individually).  Use L</GetDeleteGroups> to get a list of deletable group
+names, and see L<Image::ExifTool::TagNames|Image::ExifTool::TagNames> for a
+complete list of tag names.
 
 2) [optional] New value for tag.  Undefined to delete tag from file.  May be
@@ -1148,5 +1485,5 @@
 reference for a structure.  Integer values may be specified as a hexadecimal
 string (with a leading '0x'), and simple rational values may be specified in
-fractional form (ie. '4/10').  Structure tags may be specified either as a
+fractional form (eg. '4/10').  Structure tags may be specified either as a
 hash reference or a serialized string (see the last two examples above).
 
@@ -1159,27 +1496,42 @@
 =item AddValue
 
-Specifies that the value be added to an existing list rather than replacing
-the list.  Valid values are 0 or 1.  Default is 0.
+Specifies that the value be added to an existing list in a file rather than
+overwriting the existing values.  Valid settings are 0 (overwrite any
+existing tag value), 1 (add to an existing list and warn for non-list tags)
+or 2 (add to existing list and overwrite non-list tags).  Default is 0.
 
 =item DelValue
 
-Delete the existing tag if it has the specified value.  Valid values are
-0 or 1.  Default is 0.
+Delete existing tag from a file if it has the specified value.  For
+list-type tags this deletes a specified item from the list.  For non-list
+tags this may be used to conditionally replace a tag by providing a new
+value in a separate call to L<SetNewValue> (see examples above).  For
+structured tags, the entire structure is deleted/replaced only if all of the
+specified fields match the existing structure.  Option values are 0 or 1. 
+Default is 0.
 
 =item EditGroup
 
 Create tags in existing groups only.  Don't create new group.  Valid values
-are 0 and 1.  Default is 0.
+are 0 and 1.  Effectively removes the 'g' from the ExifTool WriteMode option
+for this tag only.  Default is 0.
 
 =item EditOnly
 
 Edit tag only if it already exists.  Don't create new tag.  Valid values are
-0 and 1.  Default is 0.
+0 and 1.  Effectively removes the 'c' from the ExifTool WriteMode option for
+this tag only.  Default is 0.
 
 =item Group
 
-Specifies group name where tag should be written.  If not specified, tag is
-written to highest priority group as specified by L</SetNewGroups>.  Any
-family 0 or 1 group name may be used.  Case is not significant.
+Specifies group name where tag should be written.  This option is superseded
+by any group specified in the tag name.  If not specified, tag is written to
+highest priority group as specified by L</SetNewGroups>.  May be one or more
+family 0, 1 or 2 groups with optional leading family number, separated by
+colons.  Case is not significant.
+
+=item NoFlat
+
+Treat flattened tags as 'unsafe'.
 
 =item NoShortcut
@@ -1197,21 +1549,28 @@
 names indicating 'unsafe' and 'protected' tags.  Default is 0.
 
+=item ProtectSaved
+
+Avoid setting new values which were saved after the Nth call to
+L</SaveNewValues>.  Has no effect on unsaved values, or values saved before
+Nth call.  Option value is N.  Default is undef.
+
 =item Replace
 
 Flag to replace the previous new values for this tag (ie. replace the values
 set in previous calls to L</SetNewValue>).  This option is most commonly
-used to replace previously-set new values for List-type tags.  Valid values
-are 0 (set new value normally -- adds to new values for List-type tags), 1
-(reset previous new values for this tag and replace with the specified new
-value) or 2 (reset previous new values only).
+used to replace previously-set new values for list-type tags.  Valid values
+are 0 (set new value normally -- adds to new values for list-type tags), 1
+(reset any previous new values before setting new value) or 2 (reset
+previous new values only; new value argument is ignored).  Default is 0.
 
 =item Shift
 
-Shift the tag by the specified value.  Currently only date/time tags can be
-shifted.  Undefined for no shift, 1 for a positive shift, or -1 for a
-negative shift.  If 0, the shift is applied only if the tag is shiftable,
-and the shift is positive if AddValue is set, or negative if DelValue is
-set.  Default is undef.  See
-L<Image::ExifTool::Shift.pl|Image::ExifTool::Shift.pl> for more information.
+Shift the tag by the specified value.  Currently only date/time tags and
+tags with numerical values may be shifted.  Undefined for no shift, 1 for a
+positive shift, or -1 for a negative shift.  A value of 0 causes a positive
+shift to be applied if the tag is shiftable and AddValue is set, or a
+negative shift for date/time tags only if DelValue is set. Default is undef.
+See L<Image::ExifTool::Shift(3pm)|Image::ExifTool::Shift.pl> for more
+information.
 
 =item Type
